{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
    {% endblock begin_javascript_fix %}


    {% block begin_javascript %}
    
    {{ parent() }}
    {{ modulename }}Obj.prototype = {
        //storeConfig:{
        //    JobRotation:{routeName:'JobRotation-getComboValues',table:'job_rotations'}
        //},
        init : function(){
            var t = this;
            t.gridLoaded=false;
            {{ modulename }}Obj.superclass.init.call(t);
            t.windowButtons.add=false;
            t.windowButtons.edit=false;
            t.windowButtons.delete=false;
            t.windowButtons.formCancel=false;
            t.windowButtons.formSubmit=false;
            t.checks = {};
	        t.stationData = {};
            t.stores.report = new mj.store({
                url : '',
                localSort : false,
                params:{}
            });
            t.stores.report.on('load', function(){
                t.waitMaskHide();
            });
            let formConfig= {
                items: [
                    new mj.form.field({
                        dataIndex: 'id',
                        hidden: true
                    }),
                    new mj.form.field({
                        dataIndex: 'version',
                        hidden: true
                    }),
                    new mj.form.dateField({
                        title : "{{ 'Reports.day'|trans }}",
                        dataIndex : 'day',
                        labelWidth : '80px',
                        width : 80,
                        defaultZero : false,
                        notEmpty:true
                    }),
                    new mj.form.combo({
                        title: "{{ 'Reports.jobrotation'|trans }}",
                        placeHolder: "{{ 'Reports.jobrotation'|trans }}",
                        dataIndex: 'jobrotation',
                        mode: 'local',
                        clearOnTriggerClick: true,
                        labelWidth : '80px',
                        grid: 's6 m4',
                        store: t.data.job_rotations
                    })
                ]
            };
            if(t.data.client_group_details.length>0){
                formConfig.items.push(
                    new mj.form.combo({
                        title: "{{ 'Reports.client_group_details'|trans }}",
                        placeHolder: "{{ 'Reports.client_group_details'|trans }}",
                        dataIndex: 'client_group_details',
                        mode: 'local',
                        clearOnTriggerClick: true,
                        labelWidth : '80px',
                        grid: 's6 m4',
                        store: t.data.client_group_details
                    })
                );
            }

            t._setFormConfig(formConfig,t.initFormElementsEvents);
            t.buttons.formSubmit = t.forms.main.addButton({
                alt: mj.lng.glb.saveAsXLS,
                cls: 'btn-sm left',
                iconCls: 'mj-save-as-xls',
                //invisible: true,
                scope: t,
                handler: t._onButtonFormSubmitClick
			});
            t.buttons.formCancel = t.forms.main.addButton({
                alt: mj.lng.glb.list,
                cls: 'btn-sm left',
                iconCls: 'mj-list',
                //invisible: true,
                scope: t,
                handler: t._onButtonFormCancelClick
			});
            t.viewContainer = new mj.panel({
                renderTo : t.tabs.main.grid.getBody(),
                buttons : [
                    {
                        iconCls:'mj-filter', 
                        title : mj.lng.glb.filter,
                        handler : function(){
                            t.tabs.main.form.activate();
                        }
                    },{
                        id:'btnPrintPreview',
                        iconCls:'mj-print-preview', 
                        title : mj.lng.glb.printPreview, 
                        handler:function(){
                            t.printPreview();
                        }
                    },{
                        id:'btnPrint',
                        iconCls:'mj-print', 
                        title : mj.lng.glb.print, 
                        handler:function(){
                            t.print();
                        }
                    }
                ]
            });
            t.customView = new mj.uretimProgramiView2({
                url : '',
                renderTo : t.viewContainer.getBody(),
                fileTitle : '',
                store : t.stores.report
            });
            t.printPreview = function(){
                var nw = mj.newWindow(), nb = $(nw.document.body);
                $(nw.document.body.previousSibling).append('<link href="'+this.printCssPath+'" type="text/css" rel="stylesheet"/>');

                mj.NE(nb, {cls:'mj-heading-1', html:this.reportTitle});
                t.customView.copyContent(nb);
                return nw;
            };
            
            t.print = function(){
                var t = this;
                var nw = t.printPreview();
                nw.print();
                nw.close();						
            };
            t.tabPanels.main.setActive(0);
        },
        editSelectedRecord: function(){
            return;
        },
        _onButtonFormCancelClick:function() {
            var t=this;
			var routeName = t.modulename + '-getReport';
            var route = Routing.getRoute(routeName);
            var pagerParams = {'pg':1,'lm':5000};
            var url = Routing.generate(routeName, pagerParams);
            t.stores.report.url=url;
            var data = this.forms.main.getValue();
            t.stores.report.preloaded=false;
            t.stores.report.params.menuId=t.id;
            t.stores.report.params.day=data.day;
            t.stores.report.params.jobrotation=data.jobrotation;
            t.stores.report.params.reportname=t.reportname;
            if(t.data.client_group_details.length>0){
                t.stores.report.params.client_group_details=data.client_group_details;
            }
            t.stores.report.load();
            t.waitMaskShow();
            t.tabs.main.grid.activate();
	    },
        /*
        _onButtonFormListClick:function(){
            var t=this;
			var routeName = t.modulename + '-getReport';
            var route = Routing.getRoute(routeName);
            var pagerParams = {'pg':1,'lm':5000};
            var url = Routing.generate(routeName, pagerParams);
            t.stores.report.url=url;
            var data = this.forms.main.getValue();
            t.stores.report.preloaded=false;
            t.stores.report.params.menuId=t.id;
            t.stores.report.params.day=data.day;
            t.stores.report.params.jobrotation=data.jobrotation;
            t.stores.report.params.reportname=t.reportname+'-2';
            if(t.data.client_group_details.length>0){
                t.stores.report.params.client_group_details=data.client_group_details;
            }
            t.stores.report.load();
            t.waitMaskShow();
            //t.tabs.main.grid.activate();
            t.tabs.main.view2.activate();
        },
        */
        save: function() {
            var t = this,
                _f = this.forms,
                f = this.forms.main;
            t.trigger('beforesave');
            if (f.modulename && typeof Routing !== 'undefined') {
                //if (f.validate()) {
                    t.waitMaskShow();
                    var id = f.getValue('id').id;
                    var versionField = f.getField('version');
                    var version = typeof versionField != "undefined" ? f.getValue('version').version : 0;
                    var mode = id ? 'update' : 'add';
                    var routeName = f.modulename + '-' + mode;
                    var route = Routing.getRoute(routeName);
                    var pagerParams = (t.grids && t.grids.main && t.grids.main.pbar) ? {
                        'pg': t.grids.main.pbar.current,
                        'lm': t.grids.main.pbar.limit
                    } : {'pg':1,'lm':25};
                    var url = Routing.generate(routeName, id ? mj.apply(pagerParams, {
                        'id': id,
                        'v': version
                    }) : pagerParams);
                    var data = f.getValue();
                    data.menuId = t.id;
                    data.reportname = t.reportname;
                    if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                        t.waitMaskShow();
                        t._event='save';
                        $.ajax({
                            url: url,
                            method: "POST",
                            headers: { 
                                "Content-Type": "application/json",
                                "X-HTTP-Method-Override": route.methods[0] 
                            },
                            data: JSON.stringify(data),
                            dataType: 'binary',
                            processData: false,
                            success: function(data, textStatus, xhr) {
                                //t.activateTabGrid();
                                if(textStatus==='success'){
                                    var filename = "";
                                    var disposition = xhr.getResponseHeader('Content-Disposition');
                                    if (disposition && disposition.indexOf('attachment') !== -1) {
                                        var filenameRegex = /filename[^;=\n]*=((['"]).*?\2|[^;\n]*)/;
                                        var matches = filenameRegex.exec(disposition);
                                        if (matches != null && matches[1]) filename = matches[1].replace(/['"]/g, '');
                                    }
                                    var type = xhr.getResponseHeader('Content-Type');
                                    var blob = typeof File === 'function'
                                        ? new File([data], filename, { type: type })
                                        : new Blob([data], { type: type });
                                    if (typeof window.navigator.msSaveBlob !== 'undefined') {
                                        // IE workaround for "HTML7007: One or more blob URLs were revoked by closing the blob for which they were created. These URLs will no longer resolve as the data backing the URL has been freed."
                                        window.navigator.msSaveBlob(blob, filename);
                                        t.waitMaskHide();
                                    } else {
                                        var URL = window.URL || window.webkitURL;
                                        var downloadUrl = URL.createObjectURL(blob);
                                        if (filename) {
                                            // use HTML5 a[download] attribute to specify filename
                                            var a = document.createElement("a");
                                            // safari doesn't support this yet
                                            if (typeof a.download === 'undefined') {
                                                window.location = downloadUrl;
                                                t.waitMaskHide();
                                            } else {
                                                a.href = downloadUrl;
                                                a.download = filename;
                                                document.body.appendChild(a);
                                                a.click();
                                                t.waitMaskHide();
                                            }
                                        } else {
                                            window.location = downloadUrl;
                                            t.waitMaskHide();
                                        }

                                        setTimeout(function () { URL.revokeObjectURL(downloadUrl); }, 100); // cleanup
                                    }
                                }
                            },
                            error: function(xhr, textStatus, errorThrown) {
                                t.waitMaskHide();
                                if(xhr.responseJSON&&xhr.responseJSON.message){
                                    mj.message({
                                        title: mj.lng.glb.error,
                                        msg: xhr.responseJSON.message,
                                        type: "error",
                                        html: true
                                    });
                                }
                            },
                            complete: function(jqXHR, textStatus) {
                                t.waitMaskHide();
                            }
                        });
                    }
                    
                //}
            }
        }
    };
    {% endblock begin_javascript %}



    {% block begin_default_module %}
    {{ parent() }}
    {% endblock begin_default_module %}



    {% block end_default_module %}
    {{ parent() }}
    {% endblock end_default_module %}


    {% block end_javascript %}
    {{ parent() }}
    {% endblock end_javascript %}


    {% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
    {{ parent() }}
{% endblock body %}
